// AcqDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "AcqDlg.h"
#include "BkDoc.h"
#include "BkView.h"
#include "Labmaster.h"
#include "EurosmartDX.h"
#include "C832DX.h"
#include "Regres.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CAcqDlg dialog
CAcqDlg::CAcqDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAcqDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAcqDlg)
	m_radioTypeDetect = -1;
	m_fAngle = 0.0f;
	m_iNbPtsMes = 0;
	m_s2 = _T("");
	//}}AFX_DATA_INIT
}
void CAcqDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAcqDlg)
	DDX_Control(pDX, IDC_PROGRESS1, m_progress);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDDEMARRER, m_btnDemarrer);
	DDX_Control(pDX, IDC_COMBO_COURBE, m_comboCourbe);
	DDX_Radio(pDX, IDC_TYPEDETECT1, m_radioTypeDetect);
	DDX_Text(pDX, IDC_DEMI_ANGLE, m_fAngle);
	DDX_Text(pDX, IDC_NB_PTS, m_iNbPtsMes);
	DDX_Text(pDX, IDC_STATIC2, m_s2);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CAcqDlg, CDialog)
	//{{AFX_MSG_MAP(CAcqDlg)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDDEMARRER, OnDemarrer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CAcqDlg message handlers
void CAcqDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
BOOL CAcqDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short i;
	CString s;
	m_pApp=(CBkApp*)AfxGetApp();
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	//Pointeur sur le document
  if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;

	m_radioTypeDetect=m_pApp->m_radioTypeDetect;
	m_fAngle=m_pApp->m_fAngle;
	m_iNbPtsMes=m_pApp->m_iNbPtsMes;

	m_pC832=new CC832DX(29600);//120000:translation, 29600:rotation
	if (m_pC832->Connect())
	{
		m_pC832->IT(1);
		if (m_pC832->OK(1))
		{
			m_OKCartePI=TRUE;
			//AfxMessageBox("Carte P.I. C-832 trouve !");
		}
		else
		{
			m_OKCartePI=FALSE;
			AfxMessageBox("Carte P.I. C-832 non trouve !");
		}
	}
	else
	{
		m_OKCartePI=FALSE;
		//AfxMessageBox("Erreur de connexion  DriverX !");
	}

	m_pEuro=new CEurosmartDX();
  if (!(m_pEuro->m_OKCarte))
  {
		//NT
		m_radioTypeDetect=1;
		GetDlgItem(IDC_TYPEDETECT1)->EnableWindow(FALSE);
		m_s2="Carte A/N Eurosmart non trouve !";
	}
	else
	{
		//Test de prsence carte AN
		if (m_pEuro->LitTension(0,0,1)==1e10)//Voie,type,nb
		{
			m_radioTypeDetect=1;
			GetDlgItem(IDC_TYPEDETECT1)->EnableWindow(FALSE);
			m_s2="Carte A/N Eurosmart non dtecte !";
		}
	}

	for (i=0;i<4;i++)
	{
		s.Format("%d",i+1);	
		m_comboCourbe.AddString(s);
	}
	m_comboCourbe.GetLBText(0,s);
	m_iCourbe=0;
	m_comboCourbe.SetWindowText(s);	
	m_progress.SetRange(0,m_iNbPtsMes);
	m_OK=FALSE;
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CAcqDlg::OnDemarrer() 
{
	short i;
	if (!m_OK)
	{
		//On dmarre
		m_OK=TRUE;
		UpdateData(TRUE);
		m_fAngle=fabs(m_fAngle);
		if (m_fAngle<3) m_fAngle=3;
		if (m_fAngle>90) m_fAngle=90;
		if (m_iNbPtsMes<3) m_iNbPtsMes=3;
		if (m_iNbPtsMes>200) m_iNbPtsMes=200;
		m_progress.SetRange(0,m_iNbPtsMes);
		if (m_comboCourbe.GetCurSel()>=0)
		{
			//Si on a touch au combo...
			m_iCourbe=m_comboCourbe.GetCurSel();
		}
		else
			m_iCourbe=0;
		UpdateData(FALSE);
		m_btnDemarrer.SetWindowText("&Arrter");
		m_btnCancel.EnableWindow(FALSE);
		GetDlgItem(IDC_TYPEDETECT1)->EnableWindow(FALSE);
		GetDlgItem(IDC_TYPEDETECT2)->EnableWindow(FALSE);
		GetDlgItem(IDC_DEMI_ANGLE)->EnableWindow(FALSE);
		GetDlgItem(IDC_COMBO_COURBE)->EnableWindow(FALSE);
		GetDlgItem(IDC_NB_PTS)->EnableWindow(FALSE);
		m_pLab=NULL;
		//(0)Labmaster: Initialisation du port srie: 1200,8,N,1
		//(1)Ultima: Initialisation du port srie: 2400,8,N,1
		if (m_radioTypeDetect==1)
		{
			m_pLab=new CLabmaster(m_pApp->m_radioTypeLab,m_pApp->m_radioComLab);
		}
		//Initialisation colonnes du tableau
		for (i=0;i<m_pDoc->m_iNbMax;i++)
		{
			m_pDoc->m_fT[i][m_iCourbe*2]=1e10;
			m_pDoc->m_fT[i][m_iCourbe*2+1]=1e10;
		}
		//Positionnement platine au point de dpart
		m_fAngleCourant=-m_fAngle;m_iN=0;
		if (m_OKCartePI)
		{
			//m_pC832->RT(1);
			//m_pC832->IT(1);
			m_pC832->SV(1,m_pApp->m_fVit);
			m_pC832->MA(1,-m_fAngle);
		}
		//Dplacement vers m_fAngle	
		SetTimer(10,40,NULL);
	}
	else
	{
		//On arrte
		Stop();
	}
}
//________________________________________
void CAcqDlg::OnTimer(UINT nIDEvent) 
{
	const float PI=4*atan(1);
	BOOL ok;
	switch (nIDEvent)
	{
		case 1:
			//Demande de mesure courante avec timer n1
			KillTimer(1);
			//Lect. compteur
			if (m_pLab!=NULL)
			{
				ok=m_pLab->Mesure();
				m_iNb=0;SetTimer(2,200,NULL);
			}
		break;
		case 2:
			//Lecture de la valeur courante avec timer n2
			m_iNb++;
			if (m_iNb>10)
			{
				m_s2.Format("(%d)(%d)\tP(mW): ?",m_iN,m_iNb);
				m_pDoc->m_sUnite="(?)";
				m_progress.SetRange(0,m_iN++);
				KillTimer(2);
				//On simule...
				m_fUP=2*pow(cos(PI*m_fAngleCourant/180),230);
				//On crit dans le tableau
				m_pDoc->m_fT[m_iN][m_iCourbe*2]=m_fAngleCourant+90*m_iCourbe;
				m_pDoc->m_fT[m_iN][m_iCourbe*2+1]=m_fUP;
				m_iN++;
				m_progress.SetPos(m_iN);
				if (m_iN>m_iNbPtsMes)
				{
					//On arrte tout...
					Stop();
				}
				else
				{
					m_fAngleCourant=m_fAngleCourant+2.0*m_iN*m_fAngle/(m_iNbPtsMes-1);
					if (m_OKCartePI) m_pC832->MA(1,m_fAngleCourant);
					SetTimer(10,40,NULL);
				}
			}
			else
			{
				if (m_pLab!=NULL)
				{				
					m_fUP=m_pLab->Lecture();
					if (m_fUP!=1e10 && m_fUP<0.030)
					{
						KillTimer(2);
						m_fUP=m_fUP*1000;
						m_s2.Format("(%d)(%d)\tP(mW): %1.3e",m_iN,m_iNb,m_fUP);
						m_pDoc->m_sUnite="P(mW)";
						//On crit dans le tableau
						m_pDoc->m_fT[m_iN][m_iCourbe*2]=m_fAngleCourant+90*m_iCourbe;
						m_pDoc->m_fT[m_iN][m_iCourbe*2+1]=m_fUP;
						m_iN++;
						m_progress.SetPos(m_iN);
						if (m_iN>=m_iNbPtsMes)
						{
							//On arrte tout...
							Stop();
						}
						else
						{
							m_fAngleCourant=m_fAngleCourant+2.0*m_fAngle/(m_iNbPtsMes-1);
							if (m_OKCartePI) m_pC832->MA(1,m_fAngleCourant);
							SetTimer(10,40,NULL);
						}
					}
				}
			}
		break;
		//Dplacement platine_________________
		case 10:
			if (!m_OKCartePI)
			{
				KillTimer(10);
				//On simule...
				m_fUP=2.0*pow(cos(PI*m_fAngleCourant/180),230);
				//On crit dans le tableau
				m_pDoc->m_fT[m_iN][m_iCourbe*2]=m_fAngleCourant+90.0*m_iCourbe;
				m_pDoc->m_fT[m_iN][m_iCourbe*2+1]=m_fUP;
				m_iN++;
				m_progress.SetPos(m_iN);
				if (m_radioTypeDetect==0)
				{
					m_s2.Format("Ang():%1.2f\nP(mW):%1.2f",m_fAngleCourant,m_fUP);
					m_pDoc->m_sUnite="P(mW)";
				}
				else
				{
					m_s2.Format("Ang():%1.2f\nU(V):%1.2f",m_fAngleCourant,m_fUP);
					m_pDoc->m_sUnite="U(V)";
				}
				if (m_iN>=m_iNbPtsMes)
				{
					//On arrte tout...
					Stop();
				}
				else
				{
					m_fAngleCourant=m_fAngleCourant+2.0*m_fAngle/(m_iNbPtsMes-1);
					SetTimer(10,40,NULL);
				}
			}
			else
			if (m_pC832->MD(1)) 
			{
				KillTimer(10);
				m_s2.Format("Ang():%1.2f",m_fAngle);
				if (m_radioTypeDetect==0)
				{
					//Eurosmart: Lecture tension
					m_fUP=m_pEuro->LitTension(m_pApp->m_iVoieAN,m_pApp->m_radioTypeAcqAN,m_pApp->m_iMoy);
					if (m_fUP==1e10)
					{
						//On simule...
						m_fUP=2*pow(cos(PI*m_fAngleCourant/180),230);
					}
					m_s2.Format("Ang():%1.2f\nU(V):%1.2f",m_fAngleCourant,m_fUP);
					m_pDoc->m_sUnite="U(V)";
					//On crit dans le tableau
					m_pDoc->m_fT[m_iN][m_iCourbe*2]=m_fAngleCourant+90*m_iCourbe;
					m_pDoc->m_fT[m_iN][m_iCourbe*2+1]=m_fUP;
					m_iN++;
					m_progress.SetPos(m_iN);
					if (m_iN>=m_iNbPtsMes)
					{
						//On arrte tout...
						Stop();
					}
					else
					{
						m_fAngleCourant=m_fAngleCourant+2.0*m_fAngle/(m_iNbPtsMes-1);
						if (m_OKCartePI) m_pC832->MA(1,m_fAngleCourant);
						SetTimer(10,40,NULL);
					}
				}
				else
				{
					//Labmaster: Lecture valeur
					SetTimer(1,100,NULL);
				}
			}
			else
			{
				//Mouvement en cours
				//m_s2.Format("- Ang():%1.2f -",m_pC832->TP(1));
			}
		break;
	}		
	UpdateData(FALSE);
	
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CAcqDlg::OnCancel() 
{
	UpdateData(TRUE);
	delete m_pEuro;
 	delete m_pC832;
	m_pApp->m_radioTypeDetect=m_radioTypeDetect;
	m_pApp->m_fAngle=m_fAngle;
	m_pApp->m_iNbPtsMes=m_iNbPtsMes;
	
	
	CDialog::OnCancel();
}
//________________________________________
void CAcqDlg::Stop() 
{
	KillTimer(1);
	KillTimer(2);
	KillTimer(10);
	if (m_radioTypeDetect==1)
	{
		delete m_pLab;
	}
	m_btnDemarrer.SetWindowText("&Demarrer");
	m_btnCancel.EnableWindow(TRUE);
 	GetDlgItem(IDC_TYPEDETECT1)->EnableWindow(TRUE);
	GetDlgItem(IDC_TYPEDETECT2)->EnableWindow(TRUE);
	GetDlgItem(IDC_DEMI_ANGLE)->EnableWindow(TRUE);
	GetDlgItem(IDC_COMBO_COURBE)->EnableWindow(TRUE);
	GetDlgItem(IDC_NB_PTS)->EnableWindow(TRUE);
	m_OK=FALSE;

	short k,n=(short)pow(2,m_iCourbe);

	if ((m_pDoc->m_iAcq&n) != n) m_pDoc->m_iAcq=m_pDoc->m_iAcq+n;

	k=abs(m_pDoc->m_iTypeGr);
	if ((k&n) != n) k=k+n;
	m_pDoc->m_iTypeGr=k;//Cartsien
	m_pDoc->m_iNb=m_pDoc->m_iNbMax;
	//Annulation rgressions
	for (n=0;n<3;n++) m_pDoc->m_pReg->m_OKTrace[n]=FALSE;
	//Annulation coordonnes relatives
	m_pDoc->m_iDx=m_pDoc->m_iDy=0;
	//Annulation zoom
	CMDIChildWnd * pChild= ((CMDIFrameWnd*)(AfxGetApp()-> m_pMainWnd)) -> MDIGetActive();
	CBkView *pView=(CBkView*)pChild->GetActiveView();
	pView->InitZoom();
	m_pDoc->UpdateAllViews(NULL);
}
