// AnDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "AnDlg.h"
#include "Bkdoc.h"
#include "EurosmartDX.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CAnDlg dialog
CAnDlg::CAnDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAnDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAnDlg)
	m_radioTypeAcqAN = -1;
	m_s1 = _T("");
	//}}AFX_DATA_INIT
}
void CAnDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAnDlg)
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDLIRE, m_btnLire);
	DDX_Control(pDX, IDC_COMBO_VOIE, m_comboVoie);
	DDX_Control(pDX, IDC_COMBO_MOY, m_comboMoy);
	DDX_Radio(pDX, IDC_RADIO_TYPE_ACQ, m_radioTypeAcqAN);
	DDX_Text(pDX, IDC_STATIC1, m_s1);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CAnDlg, CDialog)
	//{{AFX_MSG_MAP(CAnDlg)
	ON_BN_CLICKED(IDLIRE, OnLire)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CAnDlg message handlers

void CAnDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
BOOL CAnDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CString s;
	short i,j;
	m_pApp=(CBkApp*)AfxGetApp();
	for (i=0;i<8;i++)
	{
		s.Format("Voie %d",i);	
		m_comboVoie.AddString(s);
	}
	j=1;
	for (i=0;i<6;i++)
	{
		s.Format("%d",j);	
		m_comboMoy.AddString(s);
		j=j*4;
	}
	m_iVoieAN=m_pApp->m_iVoieAN;
	m_iMoyAN=m_pApp->m_iMoyAN;
	m_iMoy=m_pApp->m_iMoy;
	m_radioTypeAcqAN=m_pApp->m_radioTypeAcqAN;

	m_comboVoie.GetLBText(m_iVoieAN,s);
	m_comboVoie.SetWindowText(s);	
	s.Format("%d",m_iMoy);	
	m_comboMoy.SetWindowText(s);	
	m_OK=FALSE;
	m_pEuro=new CEurosmartDX();
	if (!m_pEuro->Connect())
	{
		m_btnLire.EnableWindow(FALSE);
		m_s1.Format("Erreur de connexion  DriverX !");
	}
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CAnDlg::OnCancel() 
{
	CString s;
	short i,j;
	UpdateData(TRUE);
	if (m_comboVoie.GetCurSel()>=0)
	{
		//Si on a touch au combo...
		m_iVoieAN=m_comboVoie.GetCurSel();
	}
	if (m_comboMoy.GetCurSel()>=0)
	{
		//Si on a touch au combo...
		m_iMoyAN=m_comboMoy.GetCurSel();
		m_iMoy=(short)pow(4,m_iMoyAN);
	}
	else
	{
		m_comboMoy.GetWindowText(s);
		i=sscanf(s,"%u",&j);
		if (i==1 && j>1 && j<2049)
		{
			m_iMoy=j;
		}
	}
	m_pApp->m_iVoieAN=m_iVoieAN;
	m_pApp->m_iMoyAN=m_iMoyAN;
	m_pApp->m_iMoy=m_iMoy;
	m_pApp->m_radioTypeAcqAN=m_radioTypeAcqAN;
	delete m_pEuro;
	CDialog::OnCancel();
}
//________________________________________
void CAnDlg::OnLire() 
{
	CString s;
	short i,j;

	UpdateData(TRUE);
	if (m_comboVoie.GetCurSel()>=0)
	{
		//Si on a touch au combo...
		m_iVoieAN=m_comboVoie.GetCurSel();
	}
	if (m_comboMoy.GetCurSel()>=0)
	{
		//Si on a touch au combo...
		m_iMoyAN=m_comboMoy.GetCurSel();
		m_iMoy=(short)pow(4,m_iMoyAN);
	}
	else
	{
		m_comboMoy.GetWindowText(s);
		i=sscanf(s,"%u",&j);
		if (i==1 && j>1 && j<2049)
		{
			m_iMoy=j;
		}
	}
	if (!m_OK)
	{
		//On lit
		m_btnLire.SetWindowText("&Arrter");
		m_btnCancel.EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO_TYPE_ACQ)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO_TYPE_ACQ1)->EnableWindow(FALSE);
		GetDlgItem(IDC_COMBO_VOIE)->EnableWindow(FALSE);
		GetDlgItem(IDC_COMBO_MOY)->EnableWindow(FALSE);
		SetTimer(1,50,NULL);
	}
	else
	{
		//On arrte
		KillTimer(1);
		GetDlgItem(IDC_RADIO_TYPE_ACQ)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_TYPE_ACQ1)->EnableWindow(TRUE);
		GetDlgItem(IDC_COMBO_VOIE)->EnableWindow(TRUE);
		GetDlgItem(IDC_COMBO_MOY)->EnableWindow(TRUE);
		m_btnCancel.EnableWindow(TRUE);
		m_btnLire.SetWindowText("&Lire");
	}
	m_OK=!m_OK;
}
//________________________________________
void CAnDlg::OnTimer(UINT nIDEvent) 
{

	float u=0;
	u=m_pEuro->LitTension(m_iVoieAN,m_radioTypeAcqAN,m_iMoy);
	if(u==1e10)
		m_s1.Format("U: ? (Carte non trouve !)");
	else
		m_s1.Format("U[%d][%d](V): %1.3f",m_iVoieAN,m_iMoy,u);
	UpdateData(FALSE);
	CDialog::OnTimer(nIDEvent);
}
