// Bk.cpp : Defines the class behaviors for the application.
#include "stdafx.h"
#include "Bk.h"
#include "MainFrm.h"
#include "ChildFrm.h"
#include "BkDoc.h"
#include "BkView.h"
#include "RegDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CBkApp
BEGIN_MESSAGE_MAP(CBkApp, CWinApp)
	//{{AFX_MSG_MAP(CBkApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()
//________________________________________
// CBkApp construction
CBkApp::CBkApp()
{
	//Botes de dialogue non modales________
	m_pRegDlg=NULL;
	//Labmaster(s)
	m_radioComLab=0;
	m_radioTypeLab=0;//0:Labmaster, 1:Ultima
	//Platine de rotation
	m_fVit=360;
	//Eurosmart
	m_iVoieAN=0;
	m_iMoy=64;m_iMoyAN=3;//1,4,16,64,256,1024 -> 64
	m_radioTypeAcqAN=0;//Uni ou bi
	//Acquisition diagrammes
	m_radioTypeDetect=0;//0:Carte AN, 1:Labmaster
	m_fAngle=30;
	m_iNbPtsMes=61;
}
//________________________________________
// The one and only CBkApp object
CBkApp theApp;
//________________________________________
// CBkApp initialization
BOOL CBkApp::InitInstance()
{
	#ifdef _AFXDLL
		Enable3dControls();			// Call this when using MFC in a shared DLL
	#else
		Enable3dControlsStatic();	// Call this when linking to MFC statically
	#endif
		LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	if (!AfxOleInit())
	{
		AfxMessageBox("Erreur d'initialisation de COM dll !");
		return FALSE;
	}

	m_iNb=0;
	m_iNbMax=4;//Nb. de fentres maxi
	m_iNo=0;

	//______________________________________
	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_BKTYPE,
		RUNTIME_CLASS(CBkDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CBkView));
	AddDocTemplate(pDocTemplate);
	//Create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;
	//Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);
	//Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;
	//The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();
	return TRUE;
}
//________________________________________
int CBkApp::ExitInstance() 
{
	return CWinApp::ExitInstance();
}
//________________________________________
// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CListBox	m_Liste;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}
void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_LISTE, m_Liste);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
// App command to run the dialog
void CBkApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}
//________________________________________
// CBkApp commands
BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_Liste.AddString("32/07/07: Nouvel icne");
	m_Liste.AddString("14/06/07: Nouvelle version C832DX");
	m_Liste.AddString("08/02/07: Ajout fonction Init avant mesures");
	m_Liste.AddString("20/10/06: Version sous DriverX");
	m_Liste.AddString("28/09/06: Correction bogue CEurosmart");
	m_Liste.AddString("21/09/06: Limitation puissance  30 mW");
	m_Liste.AddString("18/09/06: Modification classe CConRsDlg");
	m_Liste.AddString("12/09/06: Correction bogue Eurosmart");
	m_Liste.AddString("16/08/06: Version sous DriverX");
	m_Liste.AddString("10/02/05: Correction bogue coordonnes polaires");
	m_Liste.AddString("16/12/04: Copier/Coller");
	m_Liste.AddString("26/11/04: Bogue sur retour origine");
	m_Liste.AddString("21/11/04: Finalisation programme");
	m_Liste.AddString("14/11/04: Dbut criture programme");
	return TRUE;
}
//________________________________________
void CBkApp::GetDocumentSansCourant(CBkDoc *p[20])
{
	short i;
	CBkDoc *pDoc=NULL,*pAct=NULL;
	CMDIChildWnd *pChild;
	for (i=0;i<20;i++) p[i]=NULL;
	if(AfxGetApp()->m_pMainWnd)
	{
		pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) pAct=(CBkDoc*)pChild->GetActiveDocument();
		if (pAct!=NULL)
		{
			i=0;
			do
			{
				((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDINext();
				pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
				if (pChild && i<20)
				{
					pDoc=(CBkDoc*)pChild->GetActiveDocument();
					if (pDoc!=pAct) p[i]=pDoc;
				}
				i++;
			}
			while (pAct!=pDoc);
		}
	}
}
//________________________________________
void CBkApp::GetDocument(CBkDoc *p[20])
{
	short i;
	CBkDoc *pDoc=NULL;
	CMDIChildWnd *pChild;
	for (i=0;i<20;i++) p[i]=NULL;
	if(AfxGetApp()->m_pMainWnd)
	{
		pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument();
		if (pDoc!=NULL)
		{
			i=0;
			p[i]=pDoc;
			do
			{
				i++;
				((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDINext();
				pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
				if (pChild && i<20)
				{
					pDoc=(CBkDoc*)pChild->GetActiveDocument();
					if (pDoc!=p[0]) p[i]=pDoc;
				}
			}
			while (p[0]!=pDoc);
		}
	}
}
//________________________________________
CBkDoc* CBkApp::CreerNouvelleFenetre(short l,short h)
{
	CBkDoc *pDoc;
	CMDIChildWnd *pChild;
	//L'image phase existe maintenant.
	AfxGetApp()->m_pMainWnd->SendMessage(WM_COMMAND,ID_FILE_NEW,0);
	pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	pDoc=(CBkDoc*)pChild->GetActiveDocument();
	if (l>100 && h>100) pDoc->DimensionnerFenetre(l,h);
	return pDoc;
}
//________________________________________
