// BkDoc.cpp : implementation of the CBkDoc class
//
#include "stdafx.h"
#include "Bk.h"
#include "BkDoc.h"
#include "Regres.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CBkDoc
IMPLEMENT_DYNCREATE(CBkDoc, CDocument)

BEGIN_MESSAGE_MAP(CBkDoc, CDocument)
	//{{AFX_MSG_MAP(CBkDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CBkDoc construction/destruction
CBkDoc::CBkDoc()
{
	m_pView=NULL;				//Pointeur sur la vue affect dans CBkView::OnInitialUpdate
	short i,j;
	BOOL ok=FALSE;
	m_pApp=((CBkApp*)AfxGetApp());
	m_iNo=m_pApp->m_iNo;
	m_sNomFic.Format("SansNom%d",m_iNo);
	m_pApp->m_iNo++;
	m_pApp->m_iNb++;
	//Coordonnes souris____________________
	m_iDx=0;
	m_iDy=0;
	m_fDx=0;
	m_fDy=0;
	m_iX=-1;
	m_iY=-1;
	//Dimensions initiales fentre en mm____
	m_fLarg=280;
	m_fHaut=195;
	//Fentre graphique
	m_fXmi=-m_fLarg/2;
	m_fYmi=-m_fHaut/2;
	m_fXma=m_fLarg/2;
	m_fYma=m_fHaut/2;
	//Dcalage d'origine, chelles et facteurs d'chelle
	m_fXori=0;
	m_fYori=0;
	m_fEchx=1;
	m_fEchy=1;
	m_fFactx=1;
	m_fFacty=1;  
	//Dimension vue en pixel________________
	m_iL=800;
	//m_iH=600;
	m_iH=(short)(800.0*m_fHaut/m_fLarg);
	//Tableau_______________________________
  m_iNbMax=500;	//Nb. de lignes du tableau (nb. de mesures...)
	m_iNbCol=10;	//Nb. de colonnes du tableau		
  m_iNb=0;//Aucune acquisition de faite pour l'instant
  m_fT=new float[m_iNbMax][10];//10: m_iNbCol
	Init_m_fT();
	//Rgressions polynomiales______________
	m_pReg=new CRegres();
	//Oprations sur les courbes____________
	m_iTypeGr=0;//Courbes  visualiser sur le graphe:1+2+4+8+16 (4 courbes + modlisation)
	m_iAcq=0; //Courbes acquises:1+2+4+8 (maxi 4 courbes)
	for (i=0;i<5;i++)
	{
		m_fOffset[i]=0;m_fDecAng[i]=45;
		m_sIntitule[i].Format("[%d] ",i+1);
		m_fNorme[i]=1e10;
		m_OKIntitule[i]=FALSE;
		m_OKInverser[i]=FALSE;
		m_OKDecaler[i]=FALSE;
		m_OKAjouterOffset[i]=FALSE;
		m_OKNorme[i]=FALSE;
	}
	m_sUnite="(?)";
	m_sIntitule[4].Format("[5] I=I0.cos...");
	//Courbe thorique
	m_fK=9;//Teta-3dB
	m_fI0=1.0;
}
//________________________________________
CBkDoc::~CBkDoc()
{
	m_pApp->m_iNb--;
	delete[] m_fT;
	delete m_pReg;
}
//________________________________________
BOOL CBkDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
	return TRUE;
}
//////////////////////////////////////////
// CBkDoc serialization
void CBkDoc::Serialize(CArchive& ar)
{
	short i,j;
	CString s;
	CFile *fp=ar.GetFile();
	s=fp->GetFilePath();
	m_sNomFic=s;
	s.MakeLower();
	if (ar.IsStoring())
	{
		//Oprations de sauvegarde
		ar<<(short)m_iTypeGr;           
		ar<<(short)m_iNb;           
		ar<<(short)m_iNbMax;
		ar<<(short)m_iNbCol;           
		for (i=0;i<m_iNbMax;i++)
		{
			for (j=0;j<m_iNbCol;j++)
			{
				ar<<m_fT[i][j];
			}
		} 
		//Paramtres rgressions
		for (i=0;i<3;i++)
		{
			for (j=0;j<9;j++)
			{
				ar << m_pReg->m_fa[i][j];
			}
			for (j=0;j<2;j++)
			{
				ar << m_pReg->m_fP1[i][j];			
				ar << m_pReg->m_fP2[i][j];
				ar << (short)m_pReg->m_iNoColX[i][j];
				ar << (short)m_pReg->m_iNoColY[i][j];
		 		ar << (short)m_pReg->m_iNoPt[i][j];
				ar << (short)m_pReg->m_OKPt[i][j];
			}
	 		ar << (short)m_pReg->m_iNoBtn[i];
			ar << (short)m_pReg->m_iType[i];
	 		ar << (short)m_pReg->m_OKCalcul[i];
	 		ar << (short)m_pReg->m_OKTrace[i];
		}
		ar << (short)m_iTypeGr;
		ar << (short)m_iAcq;
		for (i=0;i<5;i++)
		{
			ar << m_fOffset[i];
			ar << m_fDecAng[i];
			ar << m_sIntitule[i];
			ar << m_fNorme[i];
			ar << (short)m_OKIntitule[i];
			ar << (short)m_OKInverser[i];
			ar << (short)m_OKDecaler[i];
			ar << (short)m_OKAjouterOffset[i];
			ar << (short)m_OKNorme[i];
		}
		ar << m_sUnite;
		ar << m_fK;
		ar << m_fI0;

		ar << (short)m_pApp->m_radioComLab;
		ar << (short)m_pApp->m_radioTypeLab;
		ar << m_pApp->m_fVit;
		ar << (short)m_pApp->m_iVoieAN;
		ar << (short)m_pApp->m_iMoy;
		ar << (short)m_pApp->m_iMoyAN;
		ar << (short)m_pApp->m_radioTypeAcqAN;
		ar << (short)m_pApp->m_radioTypeDetect;
		ar << m_pApp->m_fAngle;
		ar << (short)m_pApp->m_iNbPtsMes;
	}
	else
	{
		//Oprations de lecture
		ar>>(short)m_iTypeGr;           
		ar>>(short)m_iNb;
		ar>>(short)m_iNbMax;
		ar>>(short)m_iNbCol;
		for (i=0;i<m_iNb;i++)
		{
			for (j=0;j<m_iNbCol;j++)
			{
				ar>>m_fT[i][j];
			}
		}
		//Paramtres rgressions
		for (i=0;i<3;i++)
		{
			for (j=0;j<9;j++)
			{
				ar >> m_pReg->m_fa[i][j];
			}
			for (j=0;j<2;j++)
			{
				ar >> m_pReg->m_fP1[i][j];			
				ar >> m_pReg->m_fP2[i][j];
				ar >> (short&)m_pReg->m_iNoColX[i][j];
				ar >> (short&)m_pReg->m_iNoColY[i][j];
		 		ar >> (short&)m_pReg->m_iNoPt[i][j];
				ar >> (short&)m_pReg->m_OKPt[i][j];
			}
	 		ar >> (short&)m_pReg->m_iNoBtn[i];
			ar >> (short&)m_pReg->m_iType[i];
	 		ar >> (short&)m_pReg->m_OKCalcul[i];
	 		ar >> (short&)m_pReg->m_OKTrace[i];
		}
		ar >> (short&)m_iTypeGr;
		ar >> (short&)m_iAcq;
		for (i=0;i<5;i++)
		{
			ar >> m_fOffset[i];
			ar >> m_fDecAng[i];
			ar >> m_sIntitule[i];
			ar >> m_fNorme[i];
			ar >> (short&)m_OKIntitule[i];
			ar >> (short&)m_OKInverser[i];
			ar >> (short&)m_OKDecaler[i];
			ar >> (short&)m_OKAjouterOffset[i];
			ar >> (short&)m_OKNorme[i];
		}
		ar >> m_sUnite;
		ar >> m_fK;
		ar >> m_fI0;

		ar >> (short&)m_pApp->m_radioComLab;
		ar >> (short&)m_pApp->m_radioTypeLab;
		ar >> m_pApp->m_fVit;
		ar >> (short&)m_pApp->m_iVoieAN;
		ar >> (short&)m_pApp->m_iMoy;
		ar >> (short&)m_pApp->m_iMoyAN;
		ar >> (short&)m_pApp->m_radioTypeAcqAN;
		ar >> (short&)m_pApp->m_radioTypeDetect;
		ar >> m_pApp->m_fAngle;
		ar >> (short&)m_pApp->m_iNbPtsMes;
 	}
}
//////////////////////////////////////////
// CBkDoc diagnostics
#ifdef _DEBUG
void CBkDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CBkDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG
//////////////////////////////////////////
// CBkDoc commands
void CBkDoc::DimensionnerFenetre(short l,short h)
{
	//Pointeur sur l'application
	class CBkApp *pApp=((CBkApp*)AfxGetApp());
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	//Pointeur sur la vue
	class CBkView *pView;
	if (pChild) pView=(CBkView*)pChild->GetActiveView(); else pView=NULL;
	
	CRect	 MMRect,MMRect1,MMRect2;
	long l1,h1,l2,h2;
	m_pWnd->GetWindowRect(MMRect1);
	m_pWnd->GetClientRect(MMRect2);
	l1=MMRect1.right-MMRect1.left;
	h1=MMRect1.bottom-MMRect1.top;
	l2=MMRect2.right-MMRect2.left;
	h2=MMRect2.bottom-MMRect2.top;
	MMRect.SetRect(0,0,l+l1-l2+4,h+h1-h2+4);
	MMRect.OffsetRect(-MMRect.left,-MMRect.top);
	m_pWnd->SetWindowPos(NULL,l1,h1,MMRect.right,MMRect.bottom,SWP_NOACTIVATE|SWP_NOZORDER|SWP_NOMOVE|SWP_DRAWFRAME);
	m_pWnd->InvalidateRect(NULL,FALSE);
}
//________________________________________
void CBkDoc::Init_m_fT(void)
{
	short i,j;
	for (i=0;i<m_iNbMax;i++)
	{
		for (j=0;j<m_iNbCol;j++)
		{
			m_fT[i][j]=1e10;
		}
	}
	m_iNb=0;
}
//_________________________________________________
void CBkDoc::EcritTitre(void)
{
	CString s;
	short x;
	if (GetPathName().GetLength()==0)
	{
	}
	else
	{
		//GetTitle ne renvoie pas l'extension...
		if (m_sNomFic.GetLength()==0) m_sNomFic=GetPathName();
		//On enlve le chemin pour ne garder que le nom du fichier avec extension
		x=m_sNomFic.ReverseFind('\\');
		if (x>=0)	m_sNomFic=m_sNomFic.Right(m_sNomFic.GetLength()-x-1);
	}
	//s.Format("(%d) %s (%dx%d)",m_iNo,m_sNomFic,m_iL,m_iH);
	s.Format("%s",m_sNomFic);
	SetTitle(s);
}
//________________________________________
void CBkDoc::PositionnerFenetre(short l,short h)
{
	CRect	 MMRect,MMRect1,MMRect2;
	long l1,h1;
	m_pWnd->GetWindowRect(MMRect1);
	l1=MMRect1.right-MMRect1.left;
	h1=MMRect1.bottom-MMRect1.top;
	MMRect.SetRect(0,0,l1,h1);
	MMRect.OffsetRect(-MMRect.left,-MMRect.top);
	m_pWnd->SetWindowPos(NULL,l,h,MMRect.right,MMRect.bottom,SWP_NOZORDER|SWP_DRAWFRAME|SWP_SHOWWINDOW);
	m_pWnd->InvalidateRect(NULL,FALSE);
}
//________________________________________
