// BkView.cpp : implementation of the CBkView class
//
#include "stdafx.h"
#include "Bk.h"
#include "BkDoc.h"
#include "BkView.h"
#include "Dessin.h"
#include "Accro.h"
#include "Regres.h"
#include "RegDlg.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CBkView
IMPLEMENT_DYNCREATE(CBkView, CView)

BEGIN_MESSAGE_MAP(CBkView, CView)
	//{{AFX_MSG_MAP(CBkView)
	ON_UPDATE_COMMAND_UI(ID_FILE_NEW, OnUpdateFileNew)
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_UPDATE_COMMAND_UI(ID_ZOOM, OnUpdateZoom)
	ON_COMMAND(ID_ZOOM, OnZoom)
	ON_COMMAND(ID_ZOOM_TOUT, OnZoomTout)
	ON_WM_KEYDOWN()
	ON_UPDATE_COMMAND_UI(ID_FILE_OPEN, OnUpdateFileOpen)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_FICHIERTXT, OnFichiertxt)
	ON_UPDATE_COMMAND_UI(ID_FICHIERTXT, OnUpdateFichiertxt)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	//Menus contextuels
	ON_COMMAND(ID__INIT_SOURIS,InitSouris)
	ON_COMMAND(ID__ZOOM_FENETRE,ZoomFenetre)
	ON_COMMAND(ID__ZOOM_TOUT,ZoomTout)
END_MESSAGE_MAP()
//////////////////////////////////////////
// CBkView construction/destruction
CBkView::CBkView()
{
	m_pApp=(CBkApp*)AfxGetApp();
	//Zoom__________________________________
	InitZoom();
	m_tracker.m_rect.SetRectEmpty();
}
//________________________________________
CBkView::~CBkView()
{
	delete m_pAc;
}
//________________________________________
BOOL CBkView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}
//Menus contextuels_______________________
void CBkView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	//Menu contextuel -> Activ par bouton droit souris
	CBkDoc* pDoc=GetDocument(); 
	CMenu menu;
	menu.LoadMenu(IDR_POPUP);
	CMenu* pPopup=menu.GetSubMenu(0);
	//if (pDoc->m_iTypeGr==0 || pDoc->m_iTypeGr==32) menu.EnableMenuItem(ID__LEGENDE,MF_GRAYED);
	if (pPopup!=NULL) pPopup->TrackPopupMenu(TPM_LEFTALIGN|TPM_RIGHTBUTTON,point.x,point.y,this,NULL);
}
//Contextuel______________________________
void CBkView::InitSouris()
{
	//Initialisation coordonnnes relatives souris
	//class CBkApp* pApp=(CBkApp*)AfxGetApp();
	class CBkDoc *pDoc=GetDocument();
	pDoc->m_fDx=1e10;
	pDoc->m_fDy=1e10;
	pDoc->m_iDx=0;
	pDoc->m_iDy=0;
	pDoc->UpdateAllViews(NULL);
}
//Contextuel______________________________
void CBkView::ZoomFenetre()
{
	//m_tracker.m_rect.SetRectEmpty();
	OnZoom();
}
//Contextuel______________________________
void CBkView::ZoomTout()
{
	//m_tracker.m_rect.SetRectEmpty();
	OnZoomTout();
}
//Contextuel______________________________
void CBkView::PIX_FEN(short xp,short yp,float *xmm,float *ymm) 
{
	//Changement de coordonnes Souris(pixels) -> Fentre
	class CBkDoc *pDoc=GetDocument();
	float 
		x,y,
		f_ech,f_echx,f_echy;
	CRect rect;
	GetClientRect(rect);
	f_echx=rect.right/(pDoc->m_fXma-pDoc->m_fXmi);
	f_echy=rect.bottom/(pDoc->m_fYma-pDoc->m_fYmi);
	//Calcul des coordonnes souris dans le repre du graphe
	if (f_echx<f_echy) 
		f_ech=f_echx; 
	else
		f_ech=f_echy;
	*xmm=pDoc->m_fXmi+xp/f_ech;
	*ymm=pDoc->m_fYma-yp/f_ech;
}
//________________________________________
void CBkView::FEN_GR(float xmm,float ymm,float *x,float *y) 
{
 	//Changement de coordonnes Fentre -> Graphe
	class CBkDoc *pDoc=GetDocument();
	*x=(xmm/pDoc->m_fEchx+pDoc->m_fXori)*pDoc->m_fFactx;
	*y=(ymm/pDoc->m_fEchy+pDoc->m_fYori)*pDoc->m_fFacty;
}
//________________________________________
void CBkView::GR_TAB(float x,float y,float *xt,float *yt) 
{
 	//Changement de coordonnes Graphe -> Tableau de mesures
	class CBkDoc *pDoc=GetDocument();
	*xt=x/pDoc->m_fFactx;
	*yt=y/pDoc->m_fFacty;
}
//________________________________________
void CBkView::TAB_GR(float xt,float yt,float *x,float *y) 
{
 	//Changement de coordonnes Tableau de mesures -> Graphe
	class CBkDoc *pDoc=GetDocument();
	*x=xt*pDoc->m_fFactx;
	*y=yt*pDoc->m_fFacty;
}
//________________________________________
void CBkView::GR_FEN(float x,float y,float *xmm,float *ymm) 
{
 	//Changement de coordonnes Graphe -> Fentre 
	class CBkDoc *pDoc=GetDocument();
	*xmm=(x/pDoc->m_fFactx-pDoc->m_fXori)*pDoc->m_fEchx;
	*ymm=(y/pDoc->m_fFacty-pDoc->m_fYori)*pDoc->m_fEchy;
}
//________________________________________
void CBkView::FEN_PIX(float xmm,float ymm,short *xp,short *yp) 
{
	//Changement de coordonnes Fentre -> Pixel (ex: Souris)
	class CBkDoc *pDoc=GetDocument();
	float 
		x,y,
		f_ech,f_echx,f_echy;
	CRect rect;

	GetClientRect(rect);
	f_echx=rect.right/(pDoc->m_fXma-pDoc->m_fXmi);
	f_echy=rect.bottom/(pDoc->m_fYma-pDoc->m_fYmi);
	//Calcul des coordonnes souris dans le repre du graphe
	if (f_echx<f_echy) 
		f_ech=f_echx; 
	else
		f_ech=f_echy;
	*xp=(xmm-pDoc->m_fXmi)*f_ech;
	*yp=(-ymm+pDoc->m_fYma)*f_ech;
}
//________________________________________
void CBkView::MAJ_Fen()
{
	CBkDoc* pDoc=GetDocument();
	CRect r;
	GetParent()->GetWindowRect(r);
	ScreenToClient(r);
	InvalidateRect(r,FALSE);
	pDoc->UpdateAllViews(this,(LPARAM)(LPCRECT)r);
}
//________________________________________
void CBkView::MAJ_G(float xg,float yg) 
{
	CRect rect1;
	short
		x,y,
		i=55,j=50;
	float xp,yp;
	GR_FEN(xg,yg,&xp,&yp);
	FEN_PIX(xp,yp,&x,&y);
	rect1.left=x-i;rect1.right=x+i;rect1.top=y-j;rect1.bottom=y+j/2;
	InvalidateRect(rect1,FALSE);
	GetDocument()->UpdateAllViews(this,(LPARAM)(LPCRECT)rect1);
}
//________________________________________
void CBkView::OnDraw(CDC* pDC)
{
	CBkDoc* pDoc=GetDocument();
	//Nom fentre
	pDoc->EcritTitre();
	CString s;
	float PI=4*atan(1);

	CPen 
		plumeB,
		plumeR,
		plumeJ,
		*pOldPen;
	CFont 
		fntA,  
		*pOldFont;
	COLORREF clrOld;	

	fntA.CreateFont(15,0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	pOldFont=pDC->SelectObject(&fntA);	  
	pDC->SetTextAlign(TA_BASELINE);
	clrOld=pDC->SetTextColor(RGB(0,0,255));
	//Plume bleue
	plumeB.CreatePen(PS_SOLID,1,RGB(0,0,255));
 	//Plume rouge
	plumeR.CreatePen(PS_SOLID,1,RGB(255,0,0));
	//Plume jaune
	plumeJ.CreatePen(PS_SOLID,1,RGB(255,255,0));
	pOldPen=pDC->SelectObject(&plumeB);        


	CRect rect;
	GetClientRect(rect);  
	pDC->DPtoLP(rect);            
  float x,y,ech;
	if (pDC->IsPrinting())
	{
		//Dtermination du systme de coordonnes     
		pDC->SetMapMode(MM_TWIPS) ; 
		//Echelle pour sortie imprimante en fonction MM_TWIPS
		ech=1440.0/25.4;//1 twip = 1/1440e de pouce!
		//Dcalage axes
		pDC->SetWindowOrg(ech*pDoc->m_fXmi,ech*pDoc->m_fYma);
	}
	else
	{
		//1 mm est converti vers 100 pixels graphiques!
		ech=100.0;
		//Dtermination du systme de coordonnes     
		pDC->SetMapMode(MM_ISOTROPIC) ;
		//Dimensions de la fentre 
		pDC->SetWindowExt(ech*(pDoc->m_fXma-pDoc->m_fXmi),-ech*(pDoc->m_fYma-pDoc->m_fYmi));
		//Dcalage axes
		pDC->SetWindowOrg(ech*pDoc->m_fXmi,ech*pDoc->m_fYma);
		pDC->SetViewportExt(rect.right,rect.bottom);
	}
	class CDessin *pDes;
	pDes=new CDessin(pDC);
	pDes->Zoom(m_fZoomXmi,m_fZoomYmi,m_fZoomXma,m_fZoomYma);
	short err;
	//m_iTypeGr est ngatif pour un courbe polaire...
	pDes->Titre="DIAGRAMME D'EMISSION";
	short 
		i=abs(pDoc->m_iTypeGr), //Graphe  visualiser
		j=pDoc->m_iAcq;					//Graphe acquis

	if ((i&16)!=0)
	{
		//Graphe I=cos(a)^m
		pDes->Absisse(4,8,"[5] a()");
		pDes->Ordonnee(4,9,pDoc->m_sIntitule[4]);
	}	
	if (((i&8)!=0)&&((j&8)!=0) )
	{
		pDes->Absisse(3,6,"[4] a()");
		pDes->Ordonnee(3,7,pDoc->m_sIntitule[3]+pDoc->m_sUnite);
	}	
	if (((i&4)!=0)&&((j&4)!=0) )
	{
		pDes->Absisse(2,4,"[3] a()");
		pDes->Ordonnee(2,5,pDoc->m_sIntitule[2]+pDoc->m_sUnite);
	}	
	if (((i&2)!=0)&&((j&2)!=0) )
	{
		pDes->Absisse(1,2,"[2] a()");
		pDes->Ordonnee(1,3,pDoc->m_sIntitule[1]+pDoc->m_sUnite);
	}	
	if (((i&1)!=0)&&((j&1)!=0) )
	{
			pDes->Absisse(0,0,"[1] a()");
			pDes->Ordonnee(0,1,pDoc->m_sIntitule[0]+pDoc->m_sUnite);
	}	
	if (pDoc->m_iTypeGr>0)
	{
		err=pDes->Graphe(0+0+0);//Nuage de points, couleur standard, echx#echy
	}
	else
	{
		err=pDes->GrapheP(PI/180);//Angles en 
	}
	if (err==0)
	{
		//Trac de la marque de pointage  la position de la souris
		if (pDoc->m_iDx!=0 && pDoc->m_iDy!=0)
		{                          
			if (pDoc->m_iTypeGr>=0)
			{
				//Cartsien
				if (m_pAc->OK())
					pDes->MarqueDePointageVal(RGB(0,0,255),pDoc->m_fDx,pDoc->m_fDy);
				else
					pDes->MarqueDePointageVal(RGB(0,0,0),pDoc->m_fDx,pDoc->m_fDy);
			}
			else
			{
				//Polaire
					pDes->MarqueDePointageValPol(RGB(0,0,0),pDoc->m_fDx,pDoc->m_fDy);
			}
		}
		m_iZoom=-1;
	}
	//Trac des rgressions
	for (i=0;i<3;i++)
	{
		if (pDoc->m_pReg->m_OKTrace[i] && pDoc->m_pReg->m_OKCalcul[i])
		{
 			pDes->MarqueDePointage(RGB(0,255,0),pDoc->m_pReg->m_fP1[i][0],pDoc->m_pReg->m_fP1[i][1]);
 			pDes->MarqueDePointage(RGB(0,255,0),pDoc->m_pReg->m_fP2[i][0],pDoc->m_pReg->m_fP2[i][1]);
			if (pDoc->m_pReg->m_iType[i]==0)
			{
	 			//Linaire
				pDes->TraceDMC(i,pDoc->m_pReg->m_fa[i][1],pDoc->m_pReg->m_fa[i][0]);
			}
			else
			{
				//Polynomiale
				pDes->TraceReg(i,pDoc->m_pReg);
			}
		}
	}
	pDC->SelectObject(pOldPen);
	plumeB.DeleteObject(); 
	plumeR.DeleteObject(); 
	plumeJ.DeleteObject(); 
	pDC->SelectObject(pOldFont);
	fntA.DeleteObject();
	pDC->SetTextColor(clrOld);
	delete pDes;
}
//////////////////////////////////////////
// CBkView printing
BOOL CBkView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}
void CBkView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}
void CBkView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}
//////////////////////////////////////////
// CBkView diagnostics
#ifdef _DEBUG
void CBkView::AssertValid() const
{
	CView::AssertValid();
}
void CBkView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
CBkDoc* CBkView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBkDoc)));
	return (CBkDoc*)m_pDocument;
}
#endif //_DEBUG
//////////////////////////////////////////
// CBkView message handlers
void CBkView::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView) 
{
	CView::OnActivateView(bActivate, pActivateView, pDeactiveView);
}
//________________________________________
void CBkView::OnUpdateFileNew(CCmdUI* pCmdUI) 
{
	//On limite le nombre de fentres  m_iNbMax
	if (m_pApp->m_iNb>m_pApp->m_iNbMax-1)  pCmdUI->Enable(FALSE);
}
//________________________________________
void CBkView::OnUpdateFileOpen(CCmdUI* pCmdUI) 
{
	//On limite le nombre de fentres  m_iNbMax
	if (m_pApp->m_iNb>m_pApp->m_iNbMax-1)  pCmdUI->Enable(FALSE);
}
//________________________________________
void CBkView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	//Taille de la fentre
	CRect	 MMRect;
	class CBkDoc* pDoc=GetDocument();
	//Mmoriser le pointeur sur la fentre dans le document
	pDoc->m_pWnd=GetParent();
	pDoc->m_pView=this;
	pDoc->DimensionnerFenetre(pDoc->m_iL,pDoc->m_iH);
	//Classe accrochage au graphique
	m_pAc=new CAccro(pDoc,10);//10: Tableau m_fT  10 colonnes...
}
//________________________________________
void CBkView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	//Clic sur le bouton gauche de la souris
	float 
		x,y,x1,y1,x2,y2;
	CString s;
	short 
		n,i,j;
	class CRect rectSave;
	class CRectTracker tracker;
	CBkDoc* pDoc=GetDocument();
	pDoc->m_iDx=(short)point.x;
	pDoc->m_iDy=(short)point.y;
	PIX_FEN(point.x,point.y,&x,&y);
	FEN_GR(x,y,&x,&y);
	//Zoom__________________________________
	if (m_iZoom==0)
	{
		//Fentre graphique
		m_tracker.GetTrueRect(rectSave);
		if (m_tracker.HitTest(point)<0)
		{
			if (tracker.TrackRubberBand(this,point,FALSE))
			{
				tracker.m_rect.NormalizeRect();
				if (m_tracker.m_nStyle & CRectTracker::resizeInside)
				{
					m_tracker.m_nStyle &= ~CRectTracker::resizeInside;
					m_tracker.m_nStyle |= CRectTracker::resizeOutside;
				}
				else
				{
					m_tracker.m_nStyle &= ~CRectTracker::resizeOutside;
					m_tracker.m_nStyle |= CRectTracker::resizeInside;
				}
			}
			//Mise  jour des coordonnes
			m_tracker.m_rect=tracker.m_rect;
		}
		else
		if (m_tracker.Track(this,point,FALSE))
		{
			//Quand on dplace la zone digitalise...
			//pDoc->UpdateAllViews(NULL,(LPARAM)(LPCRECT)rectSave);
		}
		//Coordonnes rectangle
		PIX_FEN(m_tracker.m_rect.left,m_tracker.m_rect.top,&x,&y);
		PIX_FEN(m_tracker.m_rect.right,m_tracker.m_rect.bottom,&x1,&y1);
		FEN_GR(x,y,&x,&y);
		FEN_GR(x1,y1,&x1,&y1);
		GR_TAB(x,y,&x,&y);
		GR_TAB(x1,y1,&x1,&y1);
		Zoom(x,y1,x1,y);
		pDoc->UpdateAllViews(NULL);
	}
	else
	{
		//Ancienne position m_fDx, m_fDy
		//MAJ_G(pDoc->m_fDx,pDoc->m_fDy);
		//Pas de profil, recherche si pointage souris peut tre accroch  un graphe...
		if (pDoc->m_iTypeGr>=0)
		{
			//CARTESIEN
			if (m_pAc->AccrocheGraphe(x,y,0.02))
			{
				//x=pDoc->m_fT[m_pAc->N()][m_pAc->C1()];
				//y=pDoc->m_fT[m_pAc->N()][m_pAc->C2()];
				x=m_pAc->X();
				y=m_pAc->Y();
				TAB_GR(x,y,&x,&y);
			}
		}
		else
		{
			//POLAIRE : Pas trait...
		}
		//Nouvelle position m_fDx,m_fDy
		pDoc->m_fDx=x;
		pDoc->m_fDy=y;
		//MAJ_G(pDoc->m_fDx,pDoc->m_fDy);
		MAJ_Fen();
		//Rgressions_____________________________________
		if (m_pApp->m_pRegDlg!=NULL)
		{
			short n,no;
			float ec;
			//N de la rgression
			no=pDoc->m_pReg->m_radioNo;
			if (pDoc->m_pReg->m_iNoBtn[no]>0)
			{
				ec=pDoc->m_pReg->m_fEcart;
				//Recherche si pointage souris peut tre accroch  un graphe...
				if (m_pAc->AccrocheGraphe(pDoc->m_fDx,pDoc->m_fDy,ec))
				{
					//On a trouv !!
					x2=m_pAc->X();
					y2=m_pAc->Y();
					n=m_pAc->N();
					i=m_pAc->C1();
					j=m_pAc->C2();
					s.Format("Point %d trouv:\r\n[%d][%d] - Point n%d\r\nX:%8.3f Y:%8.3f ",pDoc->m_pReg->m_iNoBtn[no],i,j,n,x2*pDoc->m_fFactx,y2*pDoc->m_fFacty);
					m_pApp->m_pRegDlg->AffecteS(s);
					//Indice de la colonne [0,5]
	  			pDoc->m_pReg->m_iNoColX[no][pDoc->m_pReg->m_iNoBtn[no]-1]=i;
	  			pDoc->m_pReg->m_iNoColY[no][pDoc->m_pReg->m_iNoBtn[no]-1]=j;
	  			//Indice dans le tableau fT [0, m_iNb]
	  			pDoc->m_pReg->m_iNoPt[no][pDoc->m_pReg->m_iNoBtn[no]-1]=n;  
	  			//On a digitalis ce point
	  			pDoc->m_pReg->m_OKPt[no][pDoc->m_pReg->m_iNoBtn[no]-1]=TRUE;
	  			//On mmorise les coordonnes du pt. digitalis
    			if(pDoc->m_pReg->m_iNoBtn[no]==1)
    			{
    				//P1           
    				pDoc->m_pReg->m_fP1[no][0]=x2;
    				pDoc->m_pReg->m_fP1[no][1]=y2;
    			}
    			if(pDoc->m_pReg->m_iNoBtn[no]==2)
    			{
    				//P2
    				pDoc->m_pReg->m_fP2[no][0]=x2;
    				pDoc->m_pReg->m_fP2[no][1]=y2;
    			}
	  			if (pDoc->m_pReg->m_OKPt[no][0] && pDoc->m_pReg->m_OKPt[no][1] && (pDoc->m_pReg->m_iNoColX[no][0]==pDoc->m_pReg->m_iNoColX[no][1])&& (pDoc->m_pReg->m_iNoColY[no][0]==pDoc->m_pReg->m_iNoColY[no][1]) && (pDoc->m_pReg->m_iNoPt[no][0] != pDoc->m_pReg->m_iNoPt[no][1]))
	  			{
	  				//Les deux points sont digitaliss, diffrents et appartiennent  la mme courbe
	  				//On valide le bouton calcul
						m_pApp->m_pRegDlg->m_btnCalculer.EnableWindow(TRUE);
					}
				}
			}
		}
	}
	CView::OnLButtonDown(nFlags, point);
}
//________________________________________
void CBkView::OnMouseMove(UINT nFlags, CPoint point) 
{
	CBkDoc* pDoc=GetDocument();
	pDoc->m_iX=(short)point.x;
	pDoc->m_iY=(short)point.y;
	if (nFlags==MK_LBUTTON)
	{
		//Appui bouton gauche pendant dplacement

	}
	CView::OnMouseMove(nFlags, point);
}
//________________________________________
void CBkView::OnUpdateZoom(CCmdUI* pCmdUI) 
{
	if (m_iZoom==0)
	{  
		//Zoom fenetre
		pCmdUI->SetCheck(1);
	}
	else
	{ 
		pCmdUI->SetCheck(0);
	}
}
//________________________________________
void CBkView::OnZoom() 
{
	//Zoom fenetre
	//(-1:Aucun, 0:Zoom F, 1:Zoom T)
	m_iZoom=0;
}
//________________________________________
void CBkView::OnZoomTout() 
{
	class CBkDoc* pDoc=GetDocument();
	InitZoom();
	pDoc->UpdateAllViews(NULL);
}
//________________________________________
void CBkView::TraceRectTracker(CDC *pDC)
{
	CPen 
		p,
		*m_pO;
	class CBkDoc* pDoc=GetDocument();
	p.CreatePen(PS_DOT,1,RGB(255,127,127));
	m_pO=pDC->SelectObject(&p);        
	pDC->MoveTo(m_tracker.m_rect.left,m_tracker.m_rect.top);
	pDC->LineTo(m_tracker.m_rect.right,m_tracker.m_rect.top);
	pDC->LineTo(m_tracker.m_rect.right,m_tracker.m_rect.bottom);
	pDC->LineTo(m_tracker.m_rect.left,m_tracker.m_rect.bottom);
	pDC->LineTo(m_tracker.m_rect.left,m_tracker.m_rect.top);
	m_tracker.Draw(pDC);
	pDC->SelectObject(m_pO);        
	p.DeleteObject();        
}
//________________________________________
void CBkView::InitZoom(void)
{                       
	m_fZoomXmi=-1e10;
	m_fZoomXma=1e10;
	m_fZoomYmi=-1e10;
	m_fZoomYma=1e10;
	m_iZoom=-1;
	m_tracker.m_rect.SetRectEmpty();
}
//________________________________________
void CBkView::Zoom(float xmi,float ymi,float xma,float yma)
{                       
	float r;
	if (xmi>xma)
	{
		r=xmi;
		xmi=xma;
		xma=r;
	}
	if (ymi>yma)
	{
		r=ymi;
		ymi=yma;
		yma=r;
	}
	m_fZoomXmi=xmi;
	m_fZoomXma=xma;
	m_fZoomYmi=ymi;
	m_fZoomYma=yma;
}
//________________________________________
void CBkView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	float x,y;
	short i,j,k;
	class CBkDoc* pDoc=GetDocument();
	CString s;
	//Appui touche
	if (m_pAc->OK())	
	{
		if (nChar==37)
		{
			//Flche gauche
			for (k=0;k<nRepCnt;k++)
			{
				//Dcrmentation
				m_pAc->Dec();
			}
			x=m_pAc->X();
			y=m_pAc->Y();
			if (x!=1e10 && y!=1e10)
			{
				if (x>m_fZoomXmi && x<m_fZoomXma && y>m_fZoomYmi && y<m_fZoomYma)
				{
					TAB_GR(x,y,&x,&y);
					//MAJ_G(pDoc->m_fDx,pDoc->m_fDy);
	 				pDoc->m_fDx=x;
					pDoc->m_fDy=y;
					MAJ_Fen();
				}
				else
				{
					//En dehors du zoom, on reincrmente...
					for (k=0;k<nRepCnt;k++)
					{
						//Dcrmentation
						m_pAc->Inc();
					}
				}
			}
			else
			{
				//Valeur infinie, on reincrmente...
				for (k=0;k<nRepCnt;k++)
				{
					//Dcrmentation
					m_pAc->Inc();
				}
			}
		}
		if (nChar==39)
		{
			//Flche gauche
			for (k=0;k<nRepCnt;k++)
			{
				//Incrmentation
				m_pAc->Inc();
			}
			x=m_pAc->X();
			y=m_pAc->Y();
			if (x!=1e10 && y!=1e10)
			{
				if (x>=m_fZoomXmi && x<=m_fZoomXma && y>=m_fZoomYmi && y<=m_fZoomYma)
				{
					TAB_GR(x,y,&x,&y);
					//MAJ_G(pDoc->m_fDx,pDoc->m_fDy);
	 				pDoc->m_fDx=x;
					pDoc->m_fDy=y;
					MAJ_Fen();
				}
				else
				{
					//En dehors du zoom, on redcrmente...
					for (k=0;k<nRepCnt;k++)
					{
						//Dcrmentation
						m_pAc->Dec();
					}
				}
			}
			else
			{
				//Valeur infinie, on redcrmente...
				for (k=0;k<nRepCnt;k++)
				{
					//Dcrmentation
					m_pAc->Dec();
				}
			}
		}
	}
	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}
//////////////////////////////////////////
//________________________________________
void CBkView::OnFichiertxt() 
{
	//Sauver fichier compatible Excel
	CString s,s1;
	short i,j,k;
	CBkDoc* pDoc=GetDocument();
	static char BASED_CODE szFilter[] = "Fichiers texte (*.txt) | *.txt |Tous les fichiers (*.*) | *.* ||";
	//CFileDialog dlg(FALSE,"",pDoc->m_sNomFicTxt,0,szFilter,NULL) ;
	CFileDialog dlg(FALSE,"","*.txt",0,szFilter,NULL) ;

	if (dlg.DoModal()==IDOK)
	{
		//Affectation nom du fichier
		//pDoc->m_sNomFicTxt=dlg.GetPathName();
		//Ouverture du fichier
		CFile fic;
		BOOL ok;
		unsigned int j=IDYES;     
		CFileException p_Error;
		//On regarde si le fichier existe dj
		ok=fic.Open(/*pDoc->m_sNomFicTxt*/dlg.GetPathName(),CFile::modeRead,&p_Error);
		if (ok)
		{
			j=AfxMessageBox("Ce fichier existe dj. Voulez-vous le remplacer ?",MB_YESNO);
		} 
		if (j==IDYES)
		{
			if (ok) fic.Close();
			//Ouverture du fichier en mode CREATE			
			ok=fic.Open(dlg.GetPathName(),CFile::modeWrite|CFile::modeCreate,&p_Error);
			if (!ok)
			{
				AfxMessageBox("Erreur d'ouverture du fichier en mode cration !");
			}
			else
			{
				//Ecriture des donnes dans le fichier
				s.Format("Diagramme(s) de rayonnement\r\n");
				fic.Write(s,s.GetLength());
				s.Format("%6s\t%6s\t%6s\t%6s\t%6s\t%6s\t%6s\t%6s\t%6s\t%6s\r\n","a1()","U1(V)/P1(mW)","a2()","U2(V)/P2(mW)","a3()","U3(V)/P3(mW)","a4()","U4(V)/P4(mW)","a5()","U5(V)/P5(mW)");
				fic.Write(s,s.GetLength());
				for (i=0;i<pDoc->m_iNbMax;i++)
				{          
					s="";
					for (j=0;j<10;j++)
					{          
						if (pDoc->m_fT[i][j]!=1e10)
						{
							s1.Format("%6.2f\t",pDoc->m_fT[i][j]);
						}
						else
						{
							s1.Format("   \t");
						}
						s=s+s1;
					}
					s=s+"\r\n";
					fic.Write(s,s.GetLength());
				}
				fic.Close();
			}
		}
	}	
}
//________________________________________
void CBkView::OnUpdateFichiertxt(CCmdUI* pCmdUI) 
{
	if (GetDocument()->m_iNb==0)	pCmdUI->Enable(FALSE);
}
