// DepMaDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "DepMaDlg.h"
#include "C832DX.h"
#include "BkDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CDepMaDlg dialog
CDepMaDlg::CDepMaDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDepMaDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDepMaDlg)
	m_sXpos = _T("");
	m_sVit = _T("");
	m_s15 = _T("");
	//}}AFX_DATA_INIT
}
void CDepMaDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDepMaDlg)
	DDX_Control(pDX, IDC_SLIDER1, m_sliderV);
	DDX_Control(pDX, IDC_VA, m_btnVa);
	DDX_Control(pDX, IDC_STOP, m_btnStop);
	DDX_Control(pDX, IDRESET, m_btnReset);
	DDX_Control(pDX, IDC_X_PLUS, m_btnXplus);
	DDX_Control(pDX, IDC_X_MOINS, m_btnXmoins);
	DDX_Control(pDX, IDC_GH, m_btnGH);
	DDX_Control(pDX, IDC_DH, m_btnDH);
	DDX_Text(pDX, IDC_X, m_sXpos);
	DDX_Text(pDX, IDC_STATIC_VIT, m_sVit);
	DDX_Text(pDX, IDC_STATIC15, m_s15);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CDepMaDlg, CDialog)
	//{{AFX_MSG_MAP(CDepMaDlg)
	ON_BN_CLICKED(IDC_DH, OnDh)
	ON_BN_CLICKED(IDC_GH, OnGh)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_VA, OnVa)
	ON_BN_CLICKED(IDC_X_MOINS, OnXMoins)
	ON_BN_CLICKED(IDC_X_PLUS, OnXPlus)
	ON_WM_TIMER()
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDRESET, OnReset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CDepMaDlg message handlers
void CDepMaDlg::OnOK() 
{
	//Bouton supprim
	//CDialog::OnOK();
}
//________________________________________
BOOL CDepMaDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=(CBkApp*)AfxGetApp();
	m_iTypeMvt=0;	//0:Moteur  l'arrt
	m_fVit=m_pApp->m_fVit;
	m_sVit.Format("(%3.0f)",m_fVit);
	//Vitesses maximales:
	//Pour une platine de translation: 100 mm/mn
	//Pour une platine de rotation: 360/mn 
	m_sliderV.SetRange(10,360);
	m_sliderV.SetPos((short)(m_fVit));

	m_pC832=new CC832DX(29600);//120000:translation, 29600:rotation
	if (m_pC832->Connect())
	{       
		if (!m_pC832->OK(1))
		{
			m_btnGH.EnableWindow(FALSE);
			m_btnDH.EnableWindow(FALSE);
			m_btnXplus.EnableWindow(FALSE);
			m_btnXmoins.EnableWindow(FALSE);
			m_btnStop.EnableWindow(FALSE);
			m_btnVa.EnableWindow(FALSE);      
			m_sXpos="?";
			m_s15="Axe non OK !";
		} 
		else
		{
			//m_pC832->RT(1);
			//m_pC832->IT(1);
			//Nouveau : 1 axe en connexion, pour meilleure prise en compte axe 0
			m_pC832->NB(1);
			//Nouveau : axe 1 en rotation
			m_pC832->MN(1,29600);
			m_pC832->SV(1,m_fVit);
			m_btnXplus.EnableWindow(TRUE);
			m_btnXmoins.EnableWindow(TRUE);
			m_btnVa.EnableWindow(TRUE);      
			m_btnStop.EnableWindow(FALSE);
			m_sXpos.Format("%9.4f",1.0*m_pC832->TP(1));
			m_s15="Axe OK...";
		}
	}
	else
	{
		m_btnGH.EnableWindow(FALSE);
		m_btnDH.EnableWindow(FALSE);
		m_btnXplus.EnableWindow(FALSE);
		m_btnXmoins.EnableWindow(FALSE);
		m_btnStop.EnableWindow(FALSE);
		m_btnVa.EnableWindow(FALSE);      
		m_sXpos="?";
	}
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CDepMaDlg::OnDh() 
{
	if (m_pC832->OK(1))
	{
		//Define Home
		m_pC832->DH(1);
		m_sXpos.Format("%9.4f",0);
		UpdateData(FALSE);
	}
}
//________________________________________
void CDepMaDlg::OnGh() 
{
	//Go Home                           
	if (m_pC832->OK(1))
	{
		m_btnXplus.EnableWindow(FALSE);
		m_btnXmoins.EnableWindow(FALSE);
		m_btnDH.EnableWindow(FALSE);
		m_btnGH.EnableWindow(FALSE);
		m_btnVa.EnableWindow(FALSE);      
		m_btnStop.EnableWindow(TRUE);      
		m_pC832->SV(1,m_fVit);
		m_pC832->MA(1,0);
		UpdateData(FALSE);
		m_iTypeMvt=3;
		SetTimer(1,40,NULL);
  } 
}
//________________________________________
void CDepMaDlg::OnVa() 
{
	//Dplacement vers la position demande
	float x;
	int i;
	
	UpdateData(TRUE);
	i=sscanf(m_sXpos,"%f",&m_fx);
	if (m_pC832->OK(1) && i==1)
	{
		m_btnXplus.EnableWindow(FALSE);
		m_btnXmoins.EnableWindow(FALSE);
		m_btnDH.EnableWindow(FALSE);
		m_btnGH.EnableWindow(FALSE);
		m_btnVa.EnableWindow(FALSE);      
		m_btnStop.EnableWindow(TRUE);      
		m_pC832->SV(1,m_fVit);
		m_pC832->MA(1,m_fx);
		UpdateData(FALSE);
		m_iTypeMvt=4;
		SetTimer(1,40,NULL);
	} 
}
//________________________________________
void CDepMaDlg::OnCancel() 
{
	if (m_iTypeMvt!=0)
	{
		m_pC832->ST(1);
	}
	KillTimer(1);
	UpdateData(TRUE);
	m_pApp->m_fVit=m_fVit;
	delete m_pC832;	
	CDialog::OnCancel();
}
//________________________________________
void CDepMaDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	m_fVit=m_sliderV.GetPos();
	m_sVit.Format("(%3.0f)",m_fVit);
	if (m_iTypeMvt!=0)
	{
		m_pC832->ST(1);
		m_pC832->SV(1,m_fVit);
		if (m_iTypeMvt==1)
		{
			m_pC832->MR(1,100.0);
		}
		else
		if (m_iTypeMvt==2)
		{
			m_pC832->MR(1,-100.0);
		}
		else
		if (m_iTypeMvt==3)
		{
			m_pC832->MA(1,0);
		}
		if (m_iTypeMvt==4)
		{
			m_pC832->MA(1,m_fx);
		}
	}
	UpdateData(FALSE);
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
//________________________________________
void CDepMaDlg::OnReset() 
{
	//Appui sur le bouton Reset
	m_s15="Reset...";
	UpdateData(FALSE);
	m_pC832->RT(1);
	m_pC832->IT(1);
	Sleep(300);
	if (m_pC832->OK(1))
	{
		m_btnGH.EnableWindow(TRUE);
		m_btnDH.EnableWindow(TRUE);
		m_btnXplus.EnableWindow(TRUE);
		m_btnXmoins.EnableWindow(TRUE);
		m_btnVa.EnableWindow(TRUE);      
		m_btnStop.EnableWindow(FALSE);
		m_sXpos.Format("%9.4f",m_pC832->TP(1));
		m_s15="Axe OK...";
	}
	else
	{
		m_s15="Axe non OK !";
	}
	UpdateData(FALSE);
}
//________________________________________
void CDepMaDlg::OnXMoins() 
{
	if (m_pC832->OK(1))
	{
		m_btnXplus.EnableWindow(FALSE);
		m_btnXmoins.EnableWindow(FALSE);
		m_btnDH.EnableWindow(FALSE);
		m_btnVa.EnableWindow(FALSE);      
		m_btnGH.EnableWindow(FALSE);
		m_btnStop.EnableWindow(TRUE);      
		m_pC832->SV(1,m_fVit);
		m_pC832->MR(1,-100.0);
		m_iTypeMvt=2;
		SetTimer(1,40,NULL);
	} 
}
//________________________________________
void CDepMaDlg::OnXPlus() 
{
	if (m_pC832->OK(1))
	{
		m_btnXplus.EnableWindow(FALSE);
		m_btnXmoins.EnableWindow(FALSE);
		m_btnDH.EnableWindow(FALSE);
		m_btnVa.EnableWindow(FALSE);      
		m_btnGH.EnableWindow(FALSE);
		m_btnStop.EnableWindow(TRUE);      
		m_pC832->SV(1,m_fVit);
		m_pC832->MR(1,100.0);
		m_iTypeMvt=1;
		SetTimer(1,40,NULL);
	} 
}
//________________________________________
void CDepMaDlg::OnStop() 
{
	//Clic sur le bouton Stop
	KillTimer(1);
	if (m_iTypeMvt!=0)
	{
		m_pC832->ST(1);
		m_pC832->WS(1);
		m_sXpos.Format("%9.4f",m_pC832->TP(1));
		m_pC832->RI(1);
		m_btnStop.EnableWindow(FALSE);      
		m_btnXplus.EnableWindow(TRUE);
		m_btnXmoins.EnableWindow(TRUE);
		m_btnDH.EnableWindow(TRUE);
		m_btnGH.EnableWindow(TRUE);
		m_btnVa.EnableWindow(TRUE);      
		UpdateData(FALSE);
	}
	m_iTypeMvt=0;
}
//________________________________________
void CDepMaDlg::OnTimer(UINT nIDEvent) 
{
	CString s;
	if (m_iTypeMvt!=0)
	{                                   
		if (m_pC832->BT(1))
		{
			KillTimer(1);
			m_btnStop.EnableWindow(FALSE);      
			s.Format("Surcourse axe 1 dtecte !");
			AfxMessageBox(s);
		}	                    
		else 
		{ 
			m_sXpos.Format("%9.4f",m_pC832->TP(1));
			UpdateData(FALSE);
		}
		//Moteur arriv  destination
		if (m_pC832->MD(1)) 
		{
			KillTimer(1);
			m_btnStop.EnableWindow(FALSE);      
			m_btnGH.EnableWindow(TRUE);
			m_btnDH.EnableWindow(TRUE);
			m_btnXplus.EnableWindow(TRUE);
			m_btnXmoins.EnableWindow(TRUE);
			m_btnVa.EnableWindow(TRUE);      
		}
	}
	CDialog::OnTimer(nIDEvent);
}
