// GrapheDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "GrapheDlg.h"
#include "BkDoc.h"
#include "Regres.h"
#include "BkView.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CGrapheDlg dialog
CGrapheDlg::CGrapheDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGrapheDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGrapheDlg)
	m_radioType = -1;
	m_OKGraphe1 = FALSE;
	m_OKGraphe2 = FALSE;
	m_OKGraphe3 = FALSE;
	m_OKGraphe4 = FALSE;
	m_OKGraphe5 = FALSE;
	m_fK = 0.0f;
	m_fI0 = 0.0f;
	m_s3 = _T("");
	//}}AFX_DATA_INIT
}
void CGrapheDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGrapheDlg)
	DDX_Radio(pDX, IDC_RADIOTYPE, m_radioType);
	DDX_Check(pDX, IDC_GRAPHE1, m_OKGraphe1);
	DDX_Check(pDX, IDC_GRAPHE2, m_OKGraphe2);
	DDX_Check(pDX, IDC_GRAPHE3, m_OKGraphe3);
	DDX_Check(pDX, IDC_GRAPHE4, m_OKGraphe4);
	DDX_Check(pDX, IDC_GRAPHE5, m_OKGraphe5);
	DDX_Text(pDX, IDC_K, m_fK);
	DDX_Text(pDX, IDC_I0, m_fI0);
	DDX_Text(pDX, IDC_STATIC3, m_s3);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CGrapheDlg, CDialog)
	//{{AFX_MSG_MAP(CGrapheDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CGrapheDlg message handlers
BOOL CGrapheDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short i;
	m_pApp=(CBkApp*)AfxGetApp();
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	//Pointeur sur le document
  if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	i=abs(m_pDoc->m_iTypeGr);
	if ((m_pDoc->m_iAcq&1)!=1) 
		GetDlgItem(IDC_GRAPHE1)->EnableWindow(FALSE);
	else
		if ((i&1)==1) m_OKGraphe1=TRUE;
	
	if ((m_pDoc->m_iAcq&2)!=2) 
		GetDlgItem(IDC_GRAPHE2)->EnableWindow(FALSE);
	else
		if ((i&2)==2) m_OKGraphe2=TRUE;
	if ((m_pDoc->m_iAcq&4)!=4)
		GetDlgItem(IDC_GRAPHE3)->EnableWindow(FALSE);
	else
		if ((i&4)==4) m_OKGraphe3=TRUE;

	if ((m_pDoc->m_iAcq&8)!=8)
		GetDlgItem(IDC_GRAPHE4)->EnableWindow(FALSE);
	else
		if ((i&8)==8) m_OKGraphe4=TRUE;

	if ((i&16)==16) m_OKGraphe5=TRUE;

	if(m_pDoc->m_iTypeGr<0) m_radioType=1; else m_radioType=0;

	m_fK=m_pDoc->m_fK;
	m_fI0=m_pDoc->m_fI0;
	float m=-log(2)/log(cos(3.1416*m_fK/2/180));
	m_s3.Format("m: %1.2f",m);

	UpdateData(FALSE);
	
	return TRUE;
}
//________________________________________
void CGrapheDlg::OnOK() 
{
	Appli();
	//CDialog::OnOK();
}
//________________________________________
void CGrapheDlg::Appli() 
{
	short n;
	float a,m;
	UpdateData(TRUE);
	m_pDoc->m_fK=m_fK;
	m_pDoc->m_fI0=m_fI0;
	m_pDoc->m_iTypeGr=0;
	if (m_OKGraphe1) m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+1;
	if (m_OKGraphe2) m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+2;
	if (m_OKGraphe3) m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+4;
	if (m_OKGraphe4) m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+8;

	if (m_OKGraphe5)
	{
		m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+16;
		//Calcul courbe thorique
		m=-log(2)/log(cos(3.1416*m_fK/2/180));
		m_s3.Format("m: %1.2f",m);
		UpdateData(FALSE);
		n=0;
		for (a=-30;a<=30;a=a+0.5)
		{
			m_pDoc->m_fT[n][8]=a+45;
			m_pDoc->m_fT[n][9]=m_fI0*pow(cos(3.1416*a/180),m);
			n++;
		}
		m_pDoc->m_iNb=m_pDoc->m_iNbMax;
	}

	if (m_radioType==1) m_pDoc->m_iTypeGr=-m_pDoc->m_iTypeGr;
	//Annulation rgressions
	for (n=0;n<3;n++) m_pDoc->m_pReg->m_OKTrace[n]=FALSE;
	//Annulation coordonnes relatives
	m_pDoc->m_iDx=m_pDoc->m_iDy=0;
	//Annulation zoom
	CMDIChildWnd * pChild= ((CMDIFrameWnd*)(AfxGetApp()-> m_pMainWnd))->MDIGetActive();
	CBkView *pView=(CBkView*)pChild->GetActiveView();
	pView->InitZoom();
	m_pDoc->UpdateAllViews(NULL);
}
//________________________________________
void CGrapheDlg::OnCancel() 
{
	Appli();
	CDialog::OnCancel();
}
