// LabDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "LabDlg.h"
#include "BkDoc.h"
#include "Labmaster.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CLabDlg dialog
CLabDlg::CLabDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLabDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLabDlg)
	m_radioCom = -1;
	m_s = _T("");
	m_radioType = -1;
	//}}AFX_DATA_INIT
}
void CLabDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLabDlg)
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDTEST, m_btnLire);
	DDX_Radio(pDX, IDC_COM1, m_radioCom);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_s);
	DDX_Radio(pDX, IDC_LABMASTER, m_radioType);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CLabDlg, CDialog)
	//{{AFX_MSG_MAP(CLabDlg)
	ON_BN_CLICKED(IDTEST, OnTest)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CLabDlg message handlers
BOOL CLabDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=(CBkApp*)AfxGetApp();
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	//Pointeur sur le document
  if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;

	m_OKLect=FALSE;
	m_radioCom=m_pApp->m_radioComLab;	//N port srie
	m_radioType=m_pApp->m_radioTypeLab;	//Labmaster ou Ultima
	m_btnLire.SetWindowText("&Lire");  
	m_s.Format("Pour afficher la valeur courante du Labmaster, cliquer sur Lire.");
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CLabDlg::OnTest() 
{
	//Lecture de l'affichage courant Labmaster	
	UpdateData(TRUE);
	m_pApp->m_radioComLab=m_radioCom;
	m_pApp->m_radioTypeLab=m_radioType;

  m_OKLect=!m_OKLect;
	if (m_OKLect)       
	{
		m_btnLire.SetWindowText("&Arrter");  
		//Invalidation/validation des boutons
		m_btnCancel.EnableWindow(FALSE);  
		GetDlgItem(IDC_COM1)->EnableWindow(FALSE);         
		GetDlgItem(IDC_COM2)->EnableWindow(FALSE);         
		m_iN=0;
		//(0)Labmaster: Initialisation du port srie: 1200,8,N,1
		//(1)Ultima: Initialisation du port srie: 2400,8,N,1
		m_pLab=new CLabmaster(m_radioType,m_radioCom);
		SetTimer(1,100,NULL);
	}	
	else
	{
		KillTimer(1);
		KillTimer(2);
		m_btnLire.SetWindowText("&Lire");  
		//Invalidation/validation des boutons
		m_btnCancel.EnableWindow(TRUE);  
		GetDlgItem(IDC_COM1)->EnableWindow(TRUE);         
		GetDlgItem(IDC_COM2)->EnableWindow(TRUE);         
		delete m_pLab;m_pLab=NULL;
	}	
}
//________________________________________
void CLabDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void CLabDlg::OnCancel() 
{
	UpdateData(TRUE);
	m_pApp->m_radioComLab=m_radioCom;
	m_pApp->m_radioTypeLab=m_radioType;
	CDialog::OnCancel();
}
//________________________________________
void CLabDlg::OnTimer(UINT nIDEvent) 
{
	float r;
	BOOL ok;

	switch (nIDEvent)
	{
		case 1:
			//Demande de mesure courante avec timer n1
			m_iN++;
			KillTimer(1);
			//Lect. compteur
			if (m_pLab!=NULL)
			{
				ok=m_pLab->Mesure();
				m_iNb=0;
				SetTimer(2,200,NULL);
			}
		break;
		case 2:
			//Lecture de la valeur courante avec timer n2
			m_iNb++;
			if (m_iNb>10)
			{
				if (m_radioType==0)
					m_s.Format("COM%d:1200,8,'N',1,RTS/CTS\t(%d)(%d)\nP(mW): ____.___",m_radioCom+1,m_iN,m_iNb);
				else
					m_s.Format("COM%d:2400,8,'N',1,RTS/CTS\t(%d)(%d)\nP(mW): ____.___",m_radioCom+1,m_iN,m_iNb);
				KillTimer(2);
				SetTimer(1,100,NULL);
			}
			else
			{
				if (m_pLab!=NULL)
				{				
					r=m_pLab->Lecture();
					if (r!=1e10 && r<0.030)
					{
						r=r*1000;
						if (m_radioType==0)
							m_s.Format("COM%d:1200,8,'N',1,RTS/CTS\t(%d)(%d)\nP(mW): %1.3e",m_radioCom+1,m_iN,m_iNb,r);
						else
							m_s.Format("COM%d:2400,8,'N',1,RTS/CTS\t(%d)(%d)\nP(mW): %1.3e",m_radioCom+1,m_iN,m_iNb,r);
						KillTimer(2);
						SetTimer(1,100,NULL);
					}
				}
			}
		break;
	}		
	UpdateData(FALSE);
	CDialog::OnTimer(nIDEvent);
}
