// MainFrm.cpp : implementation of the CMainFrame class
//
#include "stdafx.h"
#include "Bk.h"
#include "MainFrm.h"
#include "BkDoc.h"
#include "BkView.h"
#include "RegDlg.h"
#include "DepMaDlg.h"
#include "LabDlg.h"
#include "AnDlg.h"
#include "OpeCoDlg.h"
#include "AcqDlg.h"
#include "GrapheDlg.h"
#include "CopieDlg.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CMainFrame
IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)
BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_UPDATE_COMMAND_UI(ID_EXCEL, OnUpdateExcel)
	ON_COMMAND(ID_EXCEL, OnExcel)
	ON_UPDATE_COMMAND_UI(ID_REGRESSION, OnUpdateRegression)
	ON_COMMAND(ID_REGRESSION, OnRegression)
	ON_COMMAND(ID_DEP_MANU, OnDepManu)
	ON_UPDATE_COMMAND_UI(ID_DEP_MANU, OnUpdateDepManu)
	ON_COMMAND(ID_LABMASTER, OnLabmaster)
	ON_UPDATE_COMMAND_UI(ID_CARTE_AN, OnUpdateCarteAn)
	ON_COMMAND(ID_CARTE_AN, OnCarteAn)
	ON_COMMAND(ID_OPERATION, OnOperation)
	ON_UPDATE_COMMAND_UI(ID_OPERATION, OnUpdateOperation)
	ON_COMMAND(ID_ACQ_DIA_RAY, OnAcqDiaRay)
	ON_COMMAND(ID_GRAPHES_A_TRACER, OnGraphesATracer)
	ON_COMMAND(ID_COPIERCOLLER, OnCopiercoller)
	//}}AFX_MSG_MAP
	ON_UPDATE_COMMAND_UI(ID_BK, OnUpdatePage)
END_MESSAGE_MAP()

static UINT indicators[]=
{
	ID_SEPARATOR,
	ID_BK,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	//ID_INDICATOR_SCRL,
};
//////////////////////////////////////////
// CMainFrame construction/destruction
CMainFrame::CMainFrame()
{
}
CMainFrame::~CMainFrame()
{
}
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	ShowWindow(SW_SHOWMAXIMIZED);
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CMDIFrameWnd::PreCreateWindow(cs);
}
//////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG
//////////////////////////////////////////
// CMainFrame message handlers
void CMainFrame::OnUpdatePage(CCmdUI *pCmdUI)
{
	CString 
		str,s,s1;
	class CBkDoc* pDoc=NULL;
	float a,x,y,x1,y1;
	m_pApp=((CBkApp*)AfxGetApp());

	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument();
	}
	m_wndStatusBar.SetPaneInfo(1,ID_BK,/*SBPS_STRETCH*//*SBPS_POPOUT*/SBPS_NORMAL,250);		
	if (pDoc!=NULL)
	{
		pDoc->m_pView->PIX_FEN(pDoc->m_iX,pDoc->m_iY,&x,&y);
		pDoc->m_pView->FEN_GR(x,y,&x,&y);
		pDoc->m_pView->PIX_FEN(pDoc->m_iDx,pDoc->m_iDy,&x1,&y1);
		pDoc->m_pView->FEN_GR(x1,y1,&x1,&y1);

		//Coordonnes absolues
		if (pDoc->m_iDx==0)
		{
			if (pDoc->m_iTypeGr>=0)
			{
				//Coordonnes cartsiennes
				s.Format("X:%1.3f",x);
				s1.Format("Y:%1.3f",y);
			}
			else
			{
				//Coordonnes polaires
				a=180*atan3(y,x)/3.1415;
				if (a>180) a=a-360;
				else
				if (a<-180) a=a+360;
				s.Format("R:%1.3f",pow(x*x+y*y,0.5));
				s1.Format("a():%1.3f",a);

			}
		}
		else
		{
			//Coordonnes relatives
			if (pDoc->m_iTypeGr>=0)
			{
				//Cartsien
				s.Format("dX:%1.3f",x-x1);
				s1.Format("dY:%1.3f",y-y1);
			}
			else
			{
				//Polaire
				s.Format("dR:%1.3f",pow(x*x+y*y,0.5)-pow(x1*x1+y1*y1,0.5));
				a=180*(atan3(y,x)-atan3(y1,x1))/3.1415;
				if (a>180) a=a-360;
				else
				if (a<-180) a=a+360;

				s1.Format("da():%1.3f",a);
			}
		}
		str.Format("%s, %s",s,s1); 
		pCmdUI->SetText(str);
	}
}
//________________________________________
float CMainFrame::atan3(float n,float d)
{
	float r;
	if (fabs(d)<1e-8)
		r=0;
	else
	{
		r=atan(n/d);
		if (n>0)
		{
			//Numrateur positif
			if (r>0)
			{
				//Tangente positive et numrateur positif: 1er quadrant
			}
			else
			{
				//Tangente ngative et numrateur positif: 2me quadrant
				r=r+3.1415;
			}
		}
		else
		{
			//Numrateur ngatif
			if (r>0)
			{
				//Tangente positive et numrateur ngatif: 3me quadrant
				r=r+3.1445;
			}
			else
			{
				//Tangente ngative et numrateur ngatif: 4me quadrant
				r=r+6.28;
			}

		}
	}
	return r;
}
//________________________________________
void CMainFrame::OnUpdateExcel(CCmdUI* pCmdUI) 
{
	class CBkDoc* pDoc;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc!=NULL)
	{
		if (pDoc->m_iNb==0)	pCmdUI->Enable(FALSE);
	}
	else
		pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnExcel() 
{
	//IMPORTANT: Voir CBkApp::InitInstance() et stdafx.h
	//Voir AfxOleInit()	dans Bk.cpp
	m_pApp=((CBkApp*)AfxGetApp());
	m_pAppli=new _Application();
	EcritureExcel();
	delete m_pAppli;
}
//________________________________________
void CMainFrame::EcritureExcel(void) 
{
	class CBkDoc* pDoc;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc!=NULL)
	{
		CString s[11],z;
		Range range[11];
		Workbooks books;
		_Workbook book;
		Worksheets sheets;
		_Worksheet sheet;
		short i,j;

		COleVariant 
			covTrue((short)TRUE),
			covFalse((short)FALSE),
			covOptional((long)DISP_E_PARAMNOTFOUND,VT_ERROR);
		if (!m_pAppli->CreateDispatch("Excel.Application"))
		{
			AfxMessageBox("Erreur de dmarrage Excel");
		}
		else
		{
			m_pAppli->SetVisible(TRUE);
			books=m_pAppli->GetWorkbooks();
			book=books.Add(covOptional); 
			sheets=m_pAppli->GetSheets();
			sheet=sheets.GetItem(COleVariant((short)1));
			sheet.SetName("Valeurs");

			range[0]=sheet.GetRange(COleVariant("A1"),COleVariant("A1"));
			range[0].SetValue(COleVariant("DIAGRAMME(S) DE RAYONNEMENT"));

			for (i=1;i<=10;i++)
			{
				z.Format("%c2",i+64);//A2, B2, ...
				range[i]=sheet.GetRange(COleVariant(z),COleVariant(z));//A2,B2,C2,...
			}
			//Intitul des axes
			j=1;
			for (i=1;i<=9;i=i+2)
			{
				s[i].Format("a%d()",j);
				j++;
			}
			j=1;
			for (i=2;i<=10;i=i+2)
			{
				s[i].Format("I%d(V|mW)",j);
				j++;
			}
			//Ecriture des intituls des colonnes
			for (i=1;i<=10;i++) range[i].SetValue(COleVariant(s[i]));

			for (j=0;j<=pDoc->m_iNb;j++)
			{
				for (i=1;i<=10;i++)
				{
					s[i].Format("%c%u",i+64,j+3);//On dcale de 3 lignes: A3, B3, ... J3
					range[i]=sheet.GetRange(COleVariant(s[i]),COleVariant(s[i]));
				}
				for (i=1;i<=10;i++)
				{ 
					if (pDoc->m_fT[j][i-1]!=1e10) 
						s[i].Format("%1.4f",pDoc->m_fT[j][i-1]);
					else
						s[i]="";
					range[i].SetValue(COleVariant(s[i]));
				}
			}
			//Trac des graphes
			Charts charts;
			VARIANT v;
			_Chart chart1;
			charts=m_pAppli->GetCharts();
			//Units absisses
			s[3]="a";
			s[4]="0.0E+0";
			s[5]="0.0E+0";
			v=COleVariant((short)(1));//1: Nb. de sheets  ajouter
			chart1=charts.Add(covOptional,covOptional,v);
			chart1.SetVisible(FALSE);
			s[1].Format("A2:A%u",pDoc->m_iNb+2);
			s[2].Format("B2:B%u",pDoc->m_iNb+2);
			//											Plage de donnes: s1, s2
			//															Titre du graphe: Y=f(X)
			//																								Titre du sheet: Graphe
			//																											Titre axe des absisses: s3
			GrapheExcel(sheet,chart1,s[1],s[2],"I=f(a)","Graphe",s[3],s[4],s[5]);
			//Pour ne pas avoir une demande automatique de sauvegarde...
			book.SetSaved(TRUE);
			
		}
	}
}
//________________________________________
void CMainFrame::GrapheExcel(_Worksheet sheet,_Chart chart,CString plage1,CString plage2,CString titre,CString nom,CString abs,CString FormatX,CString FormatY) 
{
	COleVariant 
		covTrue((short)TRUE),
		covFalse((short)FALSE),
		covOptional((long)DISP_E_PARAMNOTFOUND,VT_ERROR);
	LPDISPATCH pdisp;
	Axis axis;
	TickLabels tick;
	VARIANT v,v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11;
	Font fonte;
	PlotArea aire;
	Interior interieur;
	
	pdisp=sheet.GetRange(COleVariant(plage1),COleVariant(plage2));
	v1=COleVariant((short)(2));//Donnes en colonnes
	chart.ApplyCustomType(-4169,covOptional);
	chart.SetSourceData(pdisp,v1);
	v2=COleVariant((long)(-4169));//Nuage de points
	v3=COleVariant((short)(6));//Format: 1: points uniquement, 2:points relis, 4 & 5: chelles log, 6: courbe uniquement,7,8,9: !!
	v4=COleVariant((short)(2));//Donnes en colonnes
	v5=COleVariant((short)(1));//Donnes en colonnes
	v6=COleVariant((short)(1));//Donnes en colonnes
	v7=covTrue;//Avec noms des sries
	v8=COleVariant(titre);
	v9=COleVariant(abs);//Category axis title text.
	v10=covOptional;
	v11=covOptional;
	chart.ChartWizard(covOptional,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11);
	chart.SetName(nom);
	chart.SetVisible(FALSE);
	//Absisse__________________________________________
	v=COleVariant((short)(1));
	axis=chart.Axes(v,1);//Grille absisses
	axis.SetHasMajorGridlines(TRUE);
	tick=axis.GetTickLabels();
	tick.SetNumberFormat(FormatX);//Format division absisse
	//Ordonne_______________________________________
	v=COleVariant((short)(2));
	axis=chart.Axes(v,1);//Grille ordonne
	axis.SetHasMajorGridlines(TRUE);
	fonte=tick.GetFont();
	v=COleVariant((short)(9));
	fonte.SetSize(v);
	tick=axis.GetTickLabels();
	tick.SetNumberFormat(FormatY);//Format division ordonne 
	fonte=tick.GetFont();
	v=COleVariant((short)(9));
	fonte.SetSize(v);
	aire=chart.GetPlotArea();
	interieur=aire.GetInterior();
	//v=COleVariant((long)RGB(220,220,220));//Gris
	//v=COleVariant((long)RGB(255,255,200));//Jaune clair
	v=COleVariant((long)RGB(228,230,189));//Vert clair
	//v=COleVariant((long)RGB(164,223,255));//Bleu clair
	interieur.SetColor(v);
	chart.SetVisible(TRUE);
	chart.Select(covOptional);
}
//________________________________________
void CMainFrame::OnUpdateRegression(CCmdUI* pCmdUI) 
{
	class CBkDoc *pDoc=NULL;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument();
	//En polaire, pas de rgression...
	if (m_pApp->m_pRegDlg!=NULL || pDoc->m_iTypeGr<0  || pDoc->m_iNb==0) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnRegression() 
{
	if (m_pApp->m_pRegDlg==NULL)	
	{
		m_pApp->m_pRegDlg=new CRegDlg(this);
	}
}
//________________________________________
void CMainFrame::OnUpdateDepManu(CCmdUI* pCmdUI) 
{
}
//________________________________________
void CMainFrame::OnDepManu() 
{
	CDepMaDlg d;	
	d.DoModal();
}
//________________________________________
void CMainFrame::OnLabmaster() 
{
	CLabDlg d;	
	d.DoModal();
}
//________________________________________
void CMainFrame::OnUpdateCarteAn(CCmdUI* pCmdUI) 
{
}
//________________________________________
void CMainFrame::OnCarteAn() 
{
	CAnDlg d;	
	d.DoModal();
}
//________________________________________
void CMainFrame::OnUpdateOperation(CCmdUI* pCmdUI) 
{
}
//________________________________________
void CMainFrame::OnOperation() 
{
	COpeCoDlg d;	
	d.DoModal();
}
//________________________________________
void CMainFrame::OnAcqDiaRay() 
{
	CAcqDlg d;	
	d.DoModal();
}
//________________________________________
void CMainFrame::OnGraphesATracer() 
{
	CGrapheDlg d;	
	d.DoModal();
}
//________________________________________
void CMainFrame::OnCopiercoller() 
{
	CCopieDlg d;	
	d.DoModal();
}
