// Regres.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "Regres.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
CRegres::CRegres()
{
	Invalider();
	m_radioNo=0;						//N de la dmc [0,2]
	m_fEcart=0.02;
	//m_iNoBtn=1;
}
//________________________________________
CRegres::~CRegres()
{
}
//________________________________________
void CRegres::Invalider(void)
{
	short i,j;
	for (i=0;i<3;i++)
	{
		for (j=0;j<9;j++)
		{
			m_fa[i][j]=1e10;		//Initialisation coefficients rgression
		}
		for (j=0;j<2;j++)
		{
			m_fP1[i][j]=1e10;			//Coordonnes des points P1 et P2
			m_fP2[i][j]=1e10;
			m_iNoColX[i][j]=-1;
			m_iNoColY[i][j]=-1;
		 	m_iNoPt[i][j]=-1;
			m_OKPt[i][j]=FALSE;		//Point 1 et 2 non mmoris
		}
	 	m_iNoBtn[i]=0;
		m_iType[i]=0;					//Rgression linaire par dfaut
	 	m_OKCalcul[i]=FALSE;	//Coefficients DMC non calculs
	 	m_OKTrace[i]=TRUE;		//Option trac de la DMC coche par dfaut
	}
}
//________________________________________
BOOL CRegres::CalculRegres(double (*m_fT)[2],short nb,short ordre,double *Q)
{
	CString s;
	BOOL ok=TRUE;
	short
		i,j,
		k,l,c;
	double
		det,
		sy=0,sx1y=0,
		sx1=0,sx2=0;

	//Matrices pour rgressions polynomiales
	double A1,Y1,XX[20],XY[20],X1[20],a[11][11],b[11],C[11];
		
	//Initialisation coefficients
	if (nb>1)
	{
		for (k=0;k<8;k++) Q[k]=1e10;
		if (ordre==1)
		{
			//Linaire
			for (k=0;k<nb;k++)
			{
				sx1=sx1+m_fT[k][0];
				sx2=sx2+pow(m_fT[k][0],2);
				sx1y=sx1y+m_fT[k][0]*m_fT[k][1];
				sy=sy+m_fT[k][1];
			}
			det=sx2*nb-sx1*sx1;
			if (fabs(det)<1e-20)
			{
				ok=FALSE;
			}
			else
			{
				Q[1]=-(-sx1y*nb+sy*sx1)/det;
				Q[0]=(sx2*sy-sx1*sx1y)/det;  
			}
		}
		else
		{
			//Rgressions polynomiales d'aprs Yves Gurin
			//Cette mthode fonctionne pour tous les ordres polynomiaux, jusqu' 10...
			//Initialisation
			for (k=0;k<8;k++) Q[k]=0;
			for (j=0;j<20;j++)
			{
				XX[j]=0;XY[j]=0;X1[j]=0;
			}
			
			for (j=0;j<11;j++)
			{
				b[j]=0;C[j]=0;
				for (i=0;i<11;i++)
				{
					a[i][j]=0;
				}
			}
			XX[0]=nb;
			X1[0]=1;
			for (i=1;i<=nb;i++)
			{
				//Valeurs du tableau
				X1[1]=m_fT[i-1][0];
				Y1=m_fT[i-1][1];
				for (j=1;j<=2*ordre;j++)
				{
					X1[j]=X1[1]*X1[j-1];
				}
				for (j=1;j<=2*ordre;j++)
				{
					XX[j]=XX[j]+X1[j];
					XY[j]=XY[j]+Y1*X1[j-1];
				}
			}
			for (l=1;l<=ordre+1;l++)
			{
				b[l]=XY[ordre+2-l];
				for (c=1;c<=ordre+1;c++)
				{
					a[l][c]=XX[2*(ordre+1)-l-c];
				}
			}
			for (k=1;k<=ordre+1;k++)
			{
				for (l=k;l<=ordre+1;l++)
				{
					A1=a[l][k];
					b[l]=b[l]/A1;
					for (c=1;c<=ordre+1;c++)
					{
						a[l][c]=a[l][c]/A1;
					}
				}
				for (l=k+1;l<=ordre+1;l++)
				{
					b[l]=b[k]-b[l];
					for (c=1;c<=ordre+1;c++)
					{
						a[l][c]=a[k][c]-a[l][c];
					}
				}
			}
			i=0;				
			for (k=ordre+1;k>=1;k--)
			{
				C[k]=b[k];
				for (j=k+1;j<=ordre+1;j++)
				{
				C[k]=C[k]-a[k][j]*C[j];
				}
				//Affectation coefficients Q
				Q[i]=C[k];
				i++;
			}
		}
	}
	else
	{
		ok=FALSE;
	}
	return ok;
}
